Option Explicit On 
Option Strict On
Imports System.Collections

Public Class DistributorClass
    Private oDistrib As New ContactInfo  'required distributor contact info
    Private sResource As String = ""     'resource description
    Private sLiable As String = ""       'required distribution liability statement
    Private cStdOrder As New Collection  'holds integer index values that link to cStdOrderProc collection
    Private sCustom As String = ""       'the custom order process
    Private sTech As String = ""         'technical prerequisites
    Private bSingle As Boolean = False   'Single or Multiple
    Private bRange As Boolean = False    'Range or Multiple
    'Single=True & Range=False means Single
    'Single=True & Range=True means Multiple
    'Single=False & Range=True means Range
    'Single=False & Range=False means no entry in oAvail
    Private oAvail As New Collection     'holds the time period information for available time period

    Public Property Distributor() As ContactInfo
        Get
            Distributor = oDistrib
        End Get
        Set(ByVal Value As ContactInfo)
            oDistrib = Value
        End Set
    End Property

    Public Property ResourceDesc() As String
        Get
            ResourceDesc = sResource
        End Get
        Set(ByVal Value As String)
            sResource = Value
        End Set
    End Property

    Public Property Liability() As String
        Get
            Liability = sLiable
        End Get
        Set(ByVal Value As String)
            sLiable = Value
        End Set
    End Property

    Public Property StdOrderColl() As Collection
        Get
            StdOrderColl = cStdOrder
        End Get
        Set(ByVal Value As Collection)
            cStdOrder = Value
        End Set
    End Property

    Public Property CustomOrder() As String
        Get
            CustomOrder = sCustom
        End Get
        Set(ByVal Value As String)
            sCustom = Value
        End Set
    End Property

    Public Property TechReq() As String
        Get
            TechReq = sTech
        End Get
        Set(ByVal Value As String)
            sTech = Value
        End Set
    End Property

    Public Property boolSingle() As Boolean
        Get
            boolSingle = bSingle
        End Get
        Set(ByVal Value As Boolean)
            bSingle = Value
        End Set
    End Property

    Public Property boolRange() As Boolean
        Get
            boolRange = bRange
        End Get
        Set(ByVal Value As Boolean)
            bRange = Value
        End Set
    End Property

    Public Property TimeAvail() As Collection
        Get
            TimeAvail = oAvail
        End Get
        Set(ByVal Value As Collection)
            oAvail = Value
        End Set
    End Property

End Class
