Option Explicit On
Option Strict On

Imports System.Collections

Public Class EAdetailClass
    Private sEntityLabel As String = ""
    Private sEntityTypeDef As String = ""
    Private sEntityDefSource As String = ""
    Private sEntityType As String = "" 'Entity, DomainValue, or Attribute
    Private cAttribs As New Collection 'collection of integers listing index values of associated attributes in cEAttribs

    Public Sub Clear()
        sEntityLabel = ""
        sEntityDefSource = ""
        sEntityTypeDef = ""
        sEntityType = ""
        cAttribs.Clear()
    End Sub
    Public Function Duplicate() As EAdetailClass
        Dim newEntity As EAdetailClass = New EAdetailClass()
        newEntity.EntityLabel = sEntityLabel
        newEntity.DefSource = sEntityDefSource
        newEntity.EntityDef = sEntityTypeDef
        newEntity.EntityType = sEntityType
        Return newEntity
    End Function
    Public Property EntityLabel() As String
        Get
            EntityLabel = sEntityLabel
        End Get
        Set(ByVal Value As String)
            sEntityLabel = Value
        End Set
    End Property

    Public Property EntityDef() As String
        Get
            EntityDef = sEntityTypeDef
        End Get
        Set(ByVal Value As String)
            sEntityTypeDef = Value
        End Set
    End Property

    Public Property DefSource() As String
        Get
            DefSource = sEntityDefSource
        End Get
        Set(ByVal Value As String)
            sEntityDefSource = Value
        End Set
    End Property
    Public Property EntityType() As String
        Get
            EntityType = sEntityType
        End Get
        Set(ByVal value As String)
            sEntityType = value
        End Set
    End Property

    Public Property AttribColl() As Collection
        Get
            AttribColl = cAttribs
        End Get
        Set(ByVal Value As Collection)
            cAttribs = Value
        End Set
    End Property

End Class
