Option Explicit On 
Option Strict On

Imports System
Imports System.Object

Public Class ProcessClass 'implements the Process Step of Lineage in Section 2, Data Quality Information
    Private sDesc As String = ""
    Private sUsedAbbrv As String = ""
    Private sDate As String = "Unknown"
    Private sTime As String = ""
    Private sProdAbbrv As String = ""
    Private oContact As New ContactInfo

    Public Property Description() As String
        Get
            Description = sDesc
        End Get
        Set(ByVal Value As String)
            sDesc = Value
        End Set
    End Property

    Public Property UsedAbbrv() As String
        Get
            UsedAbbrv = sUsedAbbrv
        End Get
        Set(ByVal Value As String)
            sUsedAbbrv = Value
        End Set
    End Property

    Public Property ProcessDate() As String
        Get
            ProcessDate = sDate
        End Get
        Set(ByVal Value As String)
            sDate = Value
        End Set
    End Property

    Public Property ProcessTime() As String
        Get
            ProcessTime = sTime
        End Get
        Set(ByVal Value As String)
            sTime = Value
        End Set
    End Property

    Public Property ProducedAbbrv() As String
        Get
            ProducedAbbrv = sProdAbbrv
        End Get
        Set(ByVal Value As String)
            sProdAbbrv = Value
        End Set
    End Property

    Public Property ProcessContact() As ContactInfo
        Get
            ProcessContact = oContact
        End Get
        Set(ByVal Value As ContactInfo)
            oContact = Value
        End Set
    End Property

End Class
