Option Explicit On 

Imports System.Collections

Public Class frmAttribDomain
    Inherits System.Windows.Forms.Form
    Public Shared oDomainED As New AttribDomain_Enum
    Public Shared oDomainRD As New AttribDomain_Range
    Public Shared sCodeSet As String = ""
    Public Shared sUnrepped As String = ""
    Public Shared sDomType As String = "" 'possible values = unknown, enum, range, codeset, unrep
    Public Shared bUpdate As Boolean = False
    Friend WithEvents combo_parentnode As System.Windows.Forms.ComboBox
    Dim parentNodes As Collection = New Collection()
    Friend WithEvents Label17 As System.Windows.Forms.Label
    Friend WithEvents button_example As System.Windows.Forms.Button
    Private Shared sPdelim As String = ""


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        sDomType = "unknown"
    End Sub

    Public Sub New(ByVal inED As AttribDomain_Enum)
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        oDomainED = New AttribDomain_Enum
        oDomainED = inED
        sDomType = "enum"
    End Sub

    Public Sub New(ByVal inRD As AttribDomain_Range)
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        oDomainRD = New AttribDomain_Range
        oDomainRD = inRD
        sDomType = "range"
    End Sub

    Public Sub New(ByVal inDomType As String, ByVal inString As String)
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        sCodeSet = ""
        sCodeSet = inString
        sDomType = inDomType 'codeset or unrep
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents Panel2 As System.Windows.Forms.Panel
    Friend WithEvents rdoED As System.Windows.Forms.RadioButton
    Friend WithEvents rdoRD As System.Windows.Forms.RadioButton
    Friend WithEvents rdoCode As System.Windows.Forms.RadioButton
    Friend WithEvents rdoUnrep As System.Windows.Forms.RadioButton
    Friend WithEvents pnlRange As System.Windows.Forms.Panel
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents txtRMin As System.Windows.Forms.TextBox
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    Friend WithEvents txtRMax As System.Windows.Forms.TextBox
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents txtRUnits As System.Windows.Forms.TextBox
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents numResolve As System.Windows.Forms.NumericUpDown
    Friend WithEvents pnlEnum As System.Windows.Forms.Panel
    Friend WithEvents Label7 As System.Windows.Forms.Label
    Friend WithEvents pnlCode As System.Windows.Forms.Panel
    Friend WithEvents Label8 As System.Windows.Forms.Label
    Friend WithEvents Label9 As System.Windows.Forms.Label
    Friend WithEvents txtCodeName As System.Windows.Forms.TextBox
    Friend WithEvents Label10 As System.Windows.Forms.Label
    Friend WithEvents txtCodeSource As System.Windows.Forms.TextBox
    Friend WithEvents pnlUnrep As System.Windows.Forms.Panel
    Friend WithEvents Label11 As System.Windows.Forms.Label
    Friend WithEvents txtUnrep As System.Windows.Forms.TextBox
    Friend WithEvents btnOK As System.Windows.Forms.Button
    Friend WithEvents btnCancel As System.Windows.Forms.Button
    Friend WithEvents Label12 As System.Windows.Forms.Label
    Friend WithEvents txtValDefSource As System.Windows.Forms.TextBox
    Friend WithEvents Label13 As System.Windows.Forms.Label
    Friend WithEvents txtValDef As System.Windows.Forms.TextBox
    Friend WithEvents Label14 As System.Windows.Forms.Label
    Friend WithEvents txtValue As System.Windows.Forms.TextBox
    Friend WithEvents Label15 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(frmAttribDomain))
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.button_example = New System.Windows.Forms.Button
        Me.combo_parentnode = New System.Windows.Forms.ComboBox
        Me.Label17 = New System.Windows.Forms.Label
        Me.btnCancel = New System.Windows.Forms.Button
        Me.btnOK = New System.Windows.Forms.Button
        Me.pnlUnrep = New System.Windows.Forms.Panel
        Me.txtUnrep = New System.Windows.Forms.TextBox
        Me.Label11 = New System.Windows.Forms.Label
        Me.pnlCode = New System.Windows.Forms.Panel
        Me.txtCodeSource = New System.Windows.Forms.TextBox
        Me.Label10 = New System.Windows.Forms.Label
        Me.txtCodeName = New System.Windows.Forms.TextBox
        Me.Label9 = New System.Windows.Forms.Label
        Me.Label8 = New System.Windows.Forms.Label
        Me.pnlEnum = New System.Windows.Forms.Panel
        Me.txtValDefSource = New System.Windows.Forms.TextBox
        Me.Label13 = New System.Windows.Forms.Label
        Me.txtValDef = New System.Windows.Forms.TextBox
        Me.Label14 = New System.Windows.Forms.Label
        Me.txtValue = New System.Windows.Forms.TextBox
        Me.Label15 = New System.Windows.Forms.Label
        Me.Label7 = New System.Windows.Forms.Label
        Me.pnlRange = New System.Windows.Forms.Panel
        Me.numResolve = New System.Windows.Forms.NumericUpDown
        Me.Label5 = New System.Windows.Forms.Label
        Me.txtRUnits = New System.Windows.Forms.TextBox
        Me.Label4 = New System.Windows.Forms.Label
        Me.txtRMax = New System.Windows.Forms.TextBox
        Me.Label3 = New System.Windows.Forms.Label
        Me.txtRMin = New System.Windows.Forms.TextBox
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label1 = New System.Windows.Forms.Label
        Me.Panel2 = New System.Windows.Forms.Panel
        Me.rdoUnrep = New System.Windows.Forms.RadioButton
        Me.rdoCode = New System.Windows.Forms.RadioButton
        Me.rdoRD = New System.Windows.Forms.RadioButton
        Me.rdoED = New System.Windows.Forms.RadioButton
        Me.Label12 = New System.Windows.Forms.Label
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.Panel1.SuspendLayout()
        Me.pnlUnrep.SuspendLayout()
        Me.pnlCode.SuspendLayout()
        Me.pnlEnum.SuspendLayout()
        Me.pnlRange.SuspendLayout()
        CType(Me.numResolve, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.Panel2.SuspendLayout()
        Me.SuspendLayout()
        '
        'Panel1
        '
        Me.Panel1.AutoScroll = True
        Me.Panel1.Controls.Add(Me.button_example)
        Me.Panel1.Controls.Add(Me.combo_parentnode)
        Me.Panel1.Controls.Add(Me.Label17)
        Me.Panel1.Controls.Add(Me.btnCancel)
        Me.Panel1.Controls.Add(Me.btnOK)
        Me.Panel1.Controls.Add(Me.pnlUnrep)
        Me.Panel1.Controls.Add(Me.pnlCode)
        Me.Panel1.Controls.Add(Me.pnlEnum)
        Me.Panel1.Controls.Add(Me.pnlRange)
        Me.Panel1.Controls.Add(Me.Panel2)
        Me.Panel1.Controls.Add(Me.Label12)
        Me.Panel1.Location = New System.Drawing.Point(0, 0)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(619, 523)
        Me.Panel1.TabIndex = 0
        Me.ToolTip1.SetToolTip(Me.Panel1, resources.GetString("Panel1.ToolTip"))
        '
        'button_example
        '
        Me.button_example.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.button_example.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.button_example.Image = Global.MetaDoc.My.Resources.Resources.app_help_48x48
        Me.button_example.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.button_example.Location = New System.Drawing.Point(497, 12)
        Me.button_example.Name = "button_example"
        Me.button_example.Size = New System.Drawing.Size(110, 48)
        Me.button_example.TabIndex = 31
        Me.button_example.Text = "EXAMPLE"
        Me.button_example.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.button_example.UseVisualStyleBackColor = True
        '
        'combo_parentnode
        '
        Me.combo_parentnode.FormattingEnabled = True
        Me.combo_parentnode.Location = New System.Drawing.Point(100, 6)
        Me.combo_parentnode.Name = "combo_parentnode"
        Me.combo_parentnode.Size = New System.Drawing.Size(242, 21)
        Me.combo_parentnode.TabIndex = 0
        Me.ToolTip1.SetToolTip(Me.combo_parentnode, "The Node related with this Domain Value" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "You can change the related node from the" & _
                " drop-down list")
        '
        'Label17
        '
        Me.Label17.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label17.Location = New System.Drawing.Point(12, 9)
        Me.Label17.Name = "Label17"
        Me.Label17.Size = New System.Drawing.Size(82, 23)
        Me.Label17.TabIndex = 30
        Me.Label17.Text = "Parent Node:"
        Me.ToolTip1.SetToolTip(Me.Label17, "The Node related with this Domain Value" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "You can change the related node from the" & _
                " drop-down list")
        '
        'btnCancel
        '
        Me.btnCancel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnCancel.Image = Global.MetaDoc.My.Resources.Resources.Cancel_16x16
        Me.btnCancel.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnCancel.Location = New System.Drawing.Point(530, 492)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.Size = New System.Drawing.Size(75, 23)
        Me.btnCancel.TabIndex = 8
        Me.btnCancel.Text = "Cancel"
        Me.btnCancel.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnOK
        '
        Me.btnOK.Enabled = False
        Me.btnOK.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnOK.Image = Global.MetaDoc.My.Resources.Resources.Ok_16x16
        Me.btnOK.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnOK.Location = New System.Drawing.Point(449, 492)
        Me.btnOK.Name = "btnOK"
        Me.btnOK.Size = New System.Drawing.Size(75, 23)
        Me.btnOK.TabIndex = 7
        Me.btnOK.Text = "OK"
        Me.btnOK.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'pnlUnrep
        '
        Me.pnlUnrep.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.pnlUnrep.Controls.Add(Me.txtUnrep)
        Me.pnlUnrep.Controls.Add(Me.Label11)
        Me.pnlUnrep.Location = New System.Drawing.Point(299, 318)
        Me.pnlUnrep.Name = "pnlUnrep"
        Me.pnlUnrep.Size = New System.Drawing.Size(306, 168)
        Me.pnlUnrep.TabIndex = 6
        Me.ToolTip1.SetToolTip(Me.pnlUnrep, "Unrepresentable - Used to describe the values when they cannot be represented")
        '
        'txtUnrep
        '
        Me.txtUnrep.Location = New System.Drawing.Point(16, 32)
        Me.txtUnrep.Multiline = True
        Me.txtUnrep.Name = "txtUnrep"
        Me.txtUnrep.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtUnrep.Size = New System.Drawing.Size(240, 48)
        Me.txtUnrep.TabIndex = 1
        Me.ToolTip1.SetToolTip(Me.txtUnrep, "description of the values and reasons why they cannot be represented")
        '
        'Label11
        '
        Me.Label11.Dock = System.Windows.Forms.DockStyle.Top
        Me.Label11.Font = New System.Drawing.Font("Microsoft Sans Serif", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label11.Location = New System.Drawing.Point(0, 0)
        Me.Label11.Name = "Label11"
        Me.Label11.Size = New System.Drawing.Size(304, 23)
        Me.Label11.TabIndex = 0
        Me.Label11.Text = "Unrepresentable Domain"
        Me.Label11.TextAlign = System.Drawing.ContentAlignment.TopCenter
        Me.ToolTip1.SetToolTip(Me.Label11, "description of the values and reasons why they cannot be represented")
        '
        'pnlCode
        '
        Me.pnlCode.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.pnlCode.Controls.Add(Me.txtCodeSource)
        Me.pnlCode.Controls.Add(Me.Label10)
        Me.pnlCode.Controls.Add(Me.txtCodeName)
        Me.pnlCode.Controls.Add(Me.Label9)
        Me.pnlCode.Controls.Add(Me.Label8)
        Me.pnlCode.Location = New System.Drawing.Point(13, 318)
        Me.pnlCode.Name = "pnlCode"
        Me.pnlCode.Size = New System.Drawing.Size(280, 168)
        Me.pnlCode.TabIndex = 5
        Me.ToolTip1.SetToolTip(Me.pnlCode, resources.GetString("pnlCode.ToolTip"))
        '
        'txtCodeSource
        '
        Me.txtCodeSource.Location = New System.Drawing.Point(8, 104)
        Me.txtCodeSource.Multiline = True
        Me.txtCodeSource.Name = "txtCodeSource"
        Me.txtCodeSource.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtCodeSource.Size = New System.Drawing.Size(248, 48)
        Me.txtCodeSource.TabIndex = 4
        Me.ToolTip1.SetToolTip(Me.txtCodeSource, "the authority for the codeset")
        '
        'Label10
        '
        Me.Label10.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label10.Location = New System.Drawing.Point(8, 88)
        Me.Label10.Name = "Label10"
        Me.Label10.Size = New System.Drawing.Size(127, 23)
        Me.Label10.TabIndex = 3
        Me.Label10.Text = "Codeset Source"
        Me.ToolTip1.SetToolTip(Me.Label10, "the authority for the codeset")
        '
        'txtCodeName
        '
        Me.txtCodeName.Location = New System.Drawing.Point(104, 46)
        Me.txtCodeName.Multiline = True
        Me.txtCodeName.Name = "txtCodeName"
        Me.txtCodeName.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtCodeName.Size = New System.Drawing.Size(128, 26)
        Me.txtCodeName.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.txtCodeName, "the title of the codeset")
        '
        'Label9
        '
        Me.Label9.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label9.Location = New System.Drawing.Point(8, 48)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(96, 23)
        Me.Label9.TabIndex = 1
        Me.Label9.Text = "Codeset Name"
        Me.ToolTip1.SetToolTip(Me.Label9, "the title of the codeset")
        '
        'Label8
        '
        Me.Label8.Dock = System.Windows.Forms.DockStyle.Top
        Me.Label8.Font = New System.Drawing.Font("Microsoft Sans Serif", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label8.Location = New System.Drawing.Point(0, 0)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(278, 23)
        Me.Label8.TabIndex = 0
        Me.Label8.Text = "Codeset Domain"
        Me.Label8.TextAlign = System.Drawing.ContentAlignment.TopCenter
        Me.ToolTip1.SetToolTip(Me.Label8, "reference to a standard or list which contains the members of an established set " & _
                "of valid values. ")
        '
        'pnlEnum
        '
        Me.pnlEnum.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.pnlEnum.Controls.Add(Me.txtValDefSource)
        Me.pnlEnum.Controls.Add(Me.Label13)
        Me.pnlEnum.Controls.Add(Me.txtValDef)
        Me.pnlEnum.Controls.Add(Me.Label14)
        Me.pnlEnum.Controls.Add(Me.txtValue)
        Me.pnlEnum.Controls.Add(Me.Label15)
        Me.pnlEnum.Controls.Add(Me.Label7)
        Me.pnlEnum.Location = New System.Drawing.Point(13, 99)
        Me.pnlEnum.Name = "pnlEnum"
        Me.pnlEnum.Size = New System.Drawing.Size(280, 213)
        Me.pnlEnum.TabIndex = 4
        Me.ToolTip1.SetToolTip(Me.pnlEnum, resources.GetString("pnlEnum.ToolTip"))
        '
        'txtValDefSource
        '
        Me.txtValDefSource.Location = New System.Drawing.Point(72, 152)
        Me.txtValDefSource.Multiline = True
        Me.txtValDefSource.Name = "txtValDefSource"
        Me.txtValDefSource.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtValDefSource.Size = New System.Drawing.Size(184, 48)
        Me.txtValDefSource.TabIndex = 3
        Me.ToolTip1.SetToolTip(Me.txtValDefSource, "the authority of the definition")
        '
        'Label13
        '
        Me.Label13.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label13.Location = New System.Drawing.Point(8, 152)
        Me.Label13.Name = "Label13"
        Me.Label13.Size = New System.Drawing.Size(64, 40)
        Me.Label13.TabIndex = 10
        Me.Label13.Text = "Definition Source"
        Me.ToolTip1.SetToolTip(Me.Label13, "the authority of the definition")
        '
        'txtValDef
        '
        Me.txtValDef.Location = New System.Drawing.Point(72, 88)
        Me.txtValDef.Multiline = True
        Me.txtValDef.Name = "txtValDef"
        Me.txtValDef.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtValDef.Size = New System.Drawing.Size(184, 48)
        Me.txtValDef.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.txtValDef, "the description of the value")
        '
        'Label14
        '
        Me.Label14.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label14.Location = New System.Drawing.Point(8, 88)
        Me.Label14.Name = "Label14"
        Me.Label14.Size = New System.Drawing.Size(72, 23)
        Me.Label14.TabIndex = 8
        Me.Label14.Text = "Definition"
        Me.ToolTip1.SetToolTip(Me.Label14, "the description of the value")
        '
        'txtValue
        '
        Me.txtValue.Location = New System.Drawing.Point(72, 44)
        Me.txtValue.Name = "txtValue"
        Me.txtValue.Size = New System.Drawing.Size(184, 20)
        Me.txtValue.TabIndex = 1
        Me.ToolTip1.SetToolTip(Me.txtValue, "the name or label of a member of the set")
        '
        'Label15
        '
        Me.Label15.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label15.Location = New System.Drawing.Point(8, 48)
        Me.Label15.Name = "Label15"
        Me.Label15.Size = New System.Drawing.Size(48, 23)
        Me.Label15.TabIndex = 6
        Me.Label15.Text = "Value"
        Me.ToolTip1.SetToolTip(Me.Label15, "the name or label of a member of the set")
        '
        'Label7
        '
        Me.Label7.Dock = System.Windows.Forms.DockStyle.Top
        Me.Label7.Font = New System.Drawing.Font("Microsoft Sans Serif", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label7.Location = New System.Drawing.Point(0, 0)
        Me.Label7.Name = "Label7"
        Me.Label7.Size = New System.Drawing.Size(278, 23)
        Me.Label7.TabIndex = 0
        Me.Label7.Text = "Enumerated Domain"
        Me.Label7.TextAlign = System.Drawing.ContentAlignment.TopCenter
        Me.ToolTip1.SetToolTip(Me.Label7, " the members of an established set of valid values. ")
        '
        'pnlRange
        '
        Me.pnlRange.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.pnlRange.Controls.Add(Me.numResolve)
        Me.pnlRange.Controls.Add(Me.Label5)
        Me.pnlRange.Controls.Add(Me.txtRUnits)
        Me.pnlRange.Controls.Add(Me.Label4)
        Me.pnlRange.Controls.Add(Me.txtRMax)
        Me.pnlRange.Controls.Add(Me.Label3)
        Me.pnlRange.Controls.Add(Me.txtRMin)
        Me.pnlRange.Controls.Add(Me.Label2)
        Me.pnlRange.Controls.Add(Me.Label1)
        Me.pnlRange.Location = New System.Drawing.Point(299, 99)
        Me.pnlRange.Name = "pnlRange"
        Me.pnlRange.Size = New System.Drawing.Size(306, 213)
        Me.pnlRange.TabIndex = 3
        Me.ToolTip1.SetToolTip(Me.pnlRange, "the minimum and maximum values of a continuum of valid values" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "Range - Used to " & _
                "describe a continuum of valid values (e.g., weight or age)")
        '
        'numResolve
        '
        Me.numResolve.DecimalPlaces = 4
        Me.numResolve.Location = New System.Drawing.Point(178, 166)
        Me.numResolve.Maximum = New Decimal(New Integer() {100000, 0, 0, 0})
        Me.numResolve.Name = "numResolve"
        Me.numResolve.Size = New System.Drawing.Size(120, 20)
        Me.numResolve.TabIndex = 8
        Me.numResolve.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.numResolve, "the smallest unit increment to which an attribute value is measured." & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "Domain: Att" & _
                "ribute Measurement Resolution > 0.0")
        '
        'Label5
        '
        Me.Label5.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label5.Location = New System.Drawing.Point(8, 168)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(192, 23)
        Me.Label5.TabIndex = 7
        Me.Label5.Text = "Measurement Resolution (optional)"
        Me.ToolTip1.SetToolTip(Me.Label5, "the smallest unit increment to which an attribute value is measured." & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "Domain: Att" & _
                "ribute Measurement Resolution > 0.0" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10))
        '
        'txtRUnits
        '
        Me.txtRUnits.Location = New System.Drawing.Point(112, 126)
        Me.txtRUnits.Name = "txtRUnits"
        Me.txtRUnits.Size = New System.Drawing.Size(136, 20)
        Me.txtRUnits.TabIndex = 6
        Me.ToolTip1.SetToolTip(Me.txtRUnits, "the standard of measurement for an attribute value")
        '
        'Label4
        '
        Me.Label4.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label4.Location = New System.Drawing.Point(8, 128)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(104, 23)
        Me.Label4.TabIndex = 5
        Me.Label4.Text = "Units of Measure"
        Me.ToolTip1.SetToolTip(Me.Label4, "the standard of measurement for an attribute value" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10))
        '
        'txtRMax
        '
        Me.txtRMax.Location = New System.Drawing.Point(112, 86)
        Me.txtRMax.Name = "txtRMax"
        Me.txtRMax.Size = New System.Drawing.Size(136, 20)
        Me.txtRMax.TabIndex = 4
        Me.ToolTip1.SetToolTip(Me.txtRMax, "the greatest value that the attribute can be assigned" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "(text or number)")
        '
        'Label3
        '
        Me.Label3.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label3.Location = New System.Drawing.Point(8, 88)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(104, 23)
        Me.Label3.TabIndex = 3
        Me.Label3.Text = "Range Maximum"
        Me.ToolTip1.SetToolTip(Me.Label3, "the greatest value that the attribute can be assigned" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "(text or number)" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10))
        '
        'txtRMin
        '
        Me.txtRMin.Location = New System.Drawing.Point(112, 46)
        Me.txtRMin.Name = "txtRMin"
        Me.txtRMin.Size = New System.Drawing.Size(136, 20)
        Me.txtRMin.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.txtRMin, "the least value that the attribute can be assigned" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "(text or number)")
        '
        'Label2
        '
        Me.Label2.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label2.Location = New System.Drawing.Point(8, 48)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(104, 23)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Range Minimum"
        Me.ToolTip1.SetToolTip(Me.Label2, "the least value that the attribute can be assigned" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "(text or number)" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10))
        '
        'Label1
        '
        Me.Label1.Dock = System.Windows.Forms.DockStyle.Top
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.Location = New System.Drawing.Point(0, 0)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(304, 23)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Range Domain"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.TopCenter
        Me.ToolTip1.SetToolTip(Me.Label1, "the minimum and maximum values of a continuum of valid values. ")
        '
        'Panel2
        '
        Me.Panel2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Panel2.Controls.Add(Me.rdoUnrep)
        Me.Panel2.Controls.Add(Me.rdoCode)
        Me.Panel2.Controls.Add(Me.rdoRD)
        Me.Panel2.Controls.Add(Me.rdoED)
        Me.Panel2.Location = New System.Drawing.Point(14, 53)
        Me.Panel2.Name = "Panel2"
        Me.Panel2.Size = New System.Drawing.Size(384, 40)
        Me.Panel2.TabIndex = 1
        Me.Panel2.TabStop = True
        Me.ToolTip1.SetToolTip(Me.Panel2, resources.GetString("Panel2.ToolTip"))
        '
        'rdoUnrep
        '
        Me.rdoUnrep.Location = New System.Drawing.Point(256, 8)
        Me.rdoUnrep.Name = "rdoUnrep"
        Me.rdoUnrep.Size = New System.Drawing.Size(120, 24)
        Me.rdoUnrep.TabIndex = 3
        Me.rdoUnrep.TabStop = True
        Me.rdoUnrep.Text = "Unrepresentable"
        Me.ToolTip1.SetToolTip(Me.rdoUnrep, "description of the values and reasons why they cannot be represented. ")
        '
        'rdoCode
        '
        Me.rdoCode.Location = New System.Drawing.Point(176, 8)
        Me.rdoCode.Name = "rdoCode"
        Me.rdoCode.Size = New System.Drawing.Size(72, 24)
        Me.rdoCode.TabIndex = 2
        Me.rdoCode.TabStop = True
        Me.rdoCode.Text = "Codeset"
        Me.ToolTip1.SetToolTip(Me.rdoCode, "reference to a standard or list which contains the members of an established set " & _
                "of valid values. ")
        '
        'rdoRD
        '
        Me.rdoRD.Location = New System.Drawing.Point(104, 8)
        Me.rdoRD.Name = "rdoRD"
        Me.rdoRD.Size = New System.Drawing.Size(64, 24)
        Me.rdoRD.TabIndex = 1
        Me.rdoRD.TabStop = True
        Me.rdoRD.Text = "Range"
        Me.ToolTip1.SetToolTip(Me.rdoRD, "the minimum and maximum values of a continuum of valid values. ")
        '
        'rdoED
        '
        Me.rdoED.Location = New System.Drawing.Point(8, 8)
        Me.rdoED.Name = "rdoED"
        Me.rdoED.Size = New System.Drawing.Size(88, 24)
        Me.rdoED.TabIndex = 0
        Me.rdoED.TabStop = True
        Me.rdoED.Text = "Enumerated"
        Me.ToolTip1.SetToolTip(Me.rdoED, " the members of an established set of valid values. ")
        '
        'Label12
        '
        Me.Label12.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label12.Location = New System.Drawing.Point(12, 37)
        Me.Label12.Name = "Label12"
        Me.Label12.Size = New System.Drawing.Size(160, 23)
        Me.Label12.TabIndex = 9
        Me.Label12.Text = "Select value domain type:"
        '
        'ToolTip1
        '
        Me.ToolTip1.IsBalloon = True
        Me.ToolTip1.ShowAlways = True
        Me.ToolTip1.ToolTipIcon = System.Windows.Forms.ToolTipIcon.Info
        '
        'frmAttribDomain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(621, 524)
        Me.ControlBox = False
        Me.Controls.Add(Me.Panel1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "frmAttribDomain"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Attribute Domain Values"
        Me.Panel1.ResumeLayout(False)
        Me.pnlUnrep.ResumeLayout(False)
        Me.pnlUnrep.PerformLayout()
        Me.pnlCode.ResumeLayout(False)
        Me.pnlCode.PerformLayout()
        Me.pnlEnum.ResumeLayout(False)
        Me.pnlEnum.PerformLayout()
        Me.pnlRange.ResumeLayout(False)
        Me.pnlRange.PerformLayout()
        CType(Me.numResolve, System.ComponentModel.ISupportInitialize).EndInit()
        Me.Panel2.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub frmAttribDomain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim sGenArray() As String
        Dim s1 As String = ""
        Dim iCount As Integer = 0
        Dim iIndex As Integer = 0
        Dim iLoop As Integer = 0
        Dim cAttIndex As New Collection 'attribute index value collection
        Dim oGenAttrib As New AttribClass

        combo_parentnode.Items.Clear()
        For Each treenodeitem As TreeNode In frmTabDetailedDescription.treeNodes
            recursiveTreeView(treenodeitem)
        Next

        If combo_parentnode.Items.Count() = 0 Then
            MsgBox("You need to create at least one ATTRIBUTE in order to be able to add a DOMAIN VALUE", MsgBoxStyle.Exclamation, "ERROR")
            btnCancel_Click(sender, e)
        End If

        Dim oNode As TreeNode = frmTabDetailedDescription.selectedNode

        If IsNothing(oNode) = False Then combo_parentnode.SelectedIndex = combo_parentnode.FindString(oNode.Text)

        bUpdate = False
        'initially disable all data entry panels
        pnlRange.Enabled = False
        pnlEnum.Enabled = False
        pnlCode.Enabled = False
        pnlUnrep.Enabled = False
        Panel2.Enabled = True 'initially the radio buttons can be selected
        Select Case sDomType
            Case "unknown"
                'new Domain, just setup required
                oDomainED = New AttribDomain_Enum
                oDomainRD = New AttribDomain_Range
                sCodeSet = ""
                sUnrepped = ""
            Case "enum"
                'basic setup
                oDomainRD = New AttribDomain_Range
                sCodeSet = ""
                sUnrepped = ""

                'set up for Enumerated Domain
                rdoED.Checked = True
                pnlEnum.Enabled = True
                Panel2.Enabled = False 'cannot change radio button selection when editing domain
                txtValue.Text = oDomainED.DomainValue
                txtValDef.Text = oDomainED.ValueDef
                txtValDefSource.Text = oDomainED.DefSource
                'process the attribute collection, if present
                'cAttIndex = oDomainED.MoreAttributes
                'iCount = cAttIndex.Count
                'For iLoop = 1 To iCount
                '    iIndex = CType(cAttIndex(iLoop), Integer)
                '    oGenAttrib = CType(frmTabDetailedDescription.cEAttribs(iIndex), AttribClass)
                '    s1 = oGenAttrib.Label
                '    cboxEDattribs.Items.Add(s1) 'add attribute description to list box
                'Next
            Case "range"
                'basic setup
                oDomainED = New AttribDomain_Enum
                sCodeSet = ""
                sUnrepped = ""

                'set up for Range Domain
                rdoRD.Checked = True
                pnlRange.Enabled = True
                Panel2.Enabled = False 'cannot change radio button selection when editing domain
                txtRMin.Text = oDomainRD.DomMinimum     'range domain minimum
                txtRMax.Text = oDomainRD.DomMaximum     'range domain maximum
                txtRUnits.Text = oDomainRD.MeasureUnits 'measurement units
                numResolve.Value = oDomainRD.Resolution 'measurement resolution
                'process the attribute collection, if present
                'cAttIndex = oDomainRD.MoreAttributes
                'iCount = cAttIndex.Count
                'For iLoop = 1 To iCount
                '    iIndex = CType(cAttIndex(iLoop), Integer)
                '    oGenAttrib = CType(frmTabDetailedDescription.cEAttribs(iIndex), AttribClass)
                '    s1 = oGenAttrib.Label
                '    cboxRDattribs.Items.Add(s1) 'add attribute description to list box
                'Next
            Case "codeset"
                'basic setup
                oDomainED = New AttribDomain_Enum
                oDomainRD = New AttribDomain_Range
                sUnrepped = ""
                bUpdate = False

                'set up for Codeset Domain
                rdoCode.Checked = True
                pnlCode.Enabled = True
                Panel2.Enabled = False 'cannot change radio button selection when editing domain
                sGenArray = Split(sCodeSet, sPdelim)
                txtCodeName.Text = sGenArray(0)
                If (sGenArray.GetLength(0) > 1) Then
                    txtCodeSource.Text = sGenArray(1)
                Else
                    txtCodeSource.Text = ""
                End If
            Case "unrep"
                'basic setup
                oDomainED = New AttribDomain_Enum
                oDomainRD = New AttribDomain_Range
                sUnrepped = sCodeSet
                sCodeSet = ""

                'set up for Unrepresentable Domain
                rdoUnrep.Checked = True
                pnlUnrep.Enabled = True
                Panel2.Enabled = False 'cannot change radio button selection when editing domain
                txtUnrep.Text = sUnrepped
            Case Else
                s1 = "Indicator is "
                s1 += sDomType & "; report to author"
                MessageBox.Show(s1, "Domain indicator out of range", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Select
    End Sub

    Private Sub recursiveTreeView(ByVal n As TreeNode)
        Try
            Dim dummy As AttribClass = frmTabDetailedDescription.cEAttribs(n.FullPath)
            combo_parentnode.Items.Add(n.Text)
            parentNodes.Add(n)
        Catch ex As Exception
        End Try

        For Each aNode As TreeNode In n.Nodes
            recursiveTreeView(aNode)
        Next
    End Sub

    Private Sub rdoED_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoED.CheckedChanged
        If (rdoED.Checked = True) Then
            pnlEnum.Enabled = True
            sDomType = "enum"
        Else
            pnlEnum.Enabled = False
            txtValue.Text = ""
            txtValDef.Text = ""
            txtValDefSource.Text = ""
            'cboxEDattribs.Items.Clear() 'clear the list box of attributes
            oDomainED = New AttribDomain_Enum
        End If
    End Sub

    Private Sub rdoRD_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoRD.CheckedChanged
        If (rdoRD.Checked = True) Then
            pnlRange.Enabled = True
            sDomType = "range"
        Else
            pnlRange.Enabled = False
            txtRMin.Text = ""
            txtRMax.Text = ""
            txtRUnits.Text = ""
            numResolve.Value = 0
            'cboxRDattribs.Items.Clear()
            oDomainRD = New AttribDomain_Range
        End If
    End Sub

    Private Sub rdoCode_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoCode.CheckedChanged
        If (rdoCode.Checked = True) Then
            pnlCode.Enabled = True
            sDomType = "codeset"
        Else
            pnlCode.Enabled = False
            txtCodeName.Text = ""
            txtCodeSource.Text = ""
            sCodeSet = ""
        End If
    End Sub

    Private Sub rdoUnrep_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoUnrep.CheckedChanged
        If (rdoUnrep.Checked = True) Then
            pnlUnrep.Enabled = True
            sDomType = "unrep"
        Else
            pnlUnrep.Enabled = False
            txtUnrep.Text = ""
            sUnrepped = ""
        End If
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Select Case sDomType
            Case "unknown"
                'handle OK before selection of domain type
                bUpdate = False
            Case "enum"
                'handle Enumerated Domain
                bUpdate = True
                oDomainED.DomainValue = txtValue.Text
                oDomainED.ValueDef = txtValDef.Text
                oDomainED.DefSource = txtValDefSource.Text
            Case "range"
                'handle Range Domain
                bUpdate = True
                oDomainRD.DomMinimum = txtRMin.Text
                oDomainRD.DomMaximum = txtRMax.Text
                oDomainRD.MeasureUnits = txtRUnits.Text
                oDomainRD.Resolution = numResolve.Value
            Case "codeset"
                'handle Codeset Domain
                sCodeSet = txtCodeName.Text & sPdelim & txtCodeSource.Text
                bUpdate = True
            Case "unrep"
                'handle Unrepresentable Domain
                sUnrepped = txtUnrep.Text
                bUpdate = True
            Case Else
                Dim sError1 As String
                sError1 = "Misidentification of domain type! Contact program author."
                MessageBox.Show(sError1, "No domain value set", MessageBoxButtons.OK, MessageBoxIcon.Error)
                bUpdate = False
        End Select
        frmTabDetailedDescription.selectedNode2Add = combo_parentnode.SelectedItem.ToString()
        frmTabDetailedDescription.selectedNode4Add = CType(parentNodes(combo_parentnode.SelectedIndex + 1), TreeNode)
        ' resetRadioButtons()
        Me.Dispose()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        bUpdate = False
        'resetRadioButtons()
        Me.Dispose()
    End Sub

    Public Sub resetRadioButtons()
        rdoCode.Checked = False
        rdoED.Checked = False
        rdoRD.Checked = False
        rdoUnrep.Checked = False
        Panel2.Enabled = True
    End Sub

    Public Function getUpdated() As Boolean
        Return bUpdate
    End Function
    Public Function getDomType() As String
        Return sDomType
    End Function
    Public Function getDomainED() As AttribDomain_Enum
        Return oDomainED
    End Function
    Public Function getDomainRD() As AttribDomain_Range
        Return oDomainRD
    End Function
    Public Function getCodeSet() As String
        Return sCodeSet
    End Function
    Public Function getUnrepped() As String
        Return sUnrepped
    End Function

#Region "Required Fields Check"
    Private Sub txtValue_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtValue.TextChanged
        checkRequiredFields()
    End Sub

    Private Sub txtValDef_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtValDef.TextChanged
        checkRequiredFields()
    End Sub

    Private Sub txtValDefSource_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtValDefSource.TextChanged
        checkRequiredFields()
    End Sub

    Private Sub txtRMin_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtRMin.TextChanged
        checkRequiredFields()
    End Sub

    Private Sub txtRMax_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtRMax.TextChanged
        checkRequiredFields()
    End Sub

    Private Sub txtUnrep_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtUnrep.TextChanged
        checkRequiredFields()
    End Sub

    Private Sub txtCodeName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCodeName.TextChanged
        checkRequiredFields()
    End Sub

    Private Sub txtCodeSource_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCodeSource.TextChanged
        checkRequiredFields()
    End Sub

    Private Sub checkRequiredFields()

        Select Case sDomType
            Case "unknown"
                btnOK.Enabled = False
            Case "enum"
                If combo_parentnode.SelectedIndex = -1 Or txtValue.Text.Trim() = "" Or txtValDef.Text.Trim() = "" Or txtValDefSource.Text.Trim() = "" Then btnOK.Enabled = False Else btnOK.Enabled = True
            Case "range"
                If combo_parentnode.SelectedIndex = -1 Or txtRMin.Text.Trim() = "" Or txtRMax.Text.Trim() = "" Then btnOK.Enabled = False Else btnOK.Enabled = True
            Case "codeset"
                If combo_parentnode.SelectedIndex = -1 Or txtCodeName.Text.Trim() = "" Or txtCodeSource.Text.Trim() = "" Then btnOK.Enabled = False Else btnOK.Enabled = True
            Case "unrep"
                If combo_parentnode.SelectedIndex = -1 Or txtUnrep.Text.Trim() = "" Then btnOK.Enabled = False Else btnOK.Enabled = True
            Case Else
                btnOK.Enabled = False
        End Select
    End Sub

    Private Sub combo_parentnode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles combo_parentnode.SelectedIndexChanged
        checkRequiredFields()
    End Sub
#End Region

    Private Sub button_example_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_example.Click
        Dim helpForm As dialog_help = New dialog_help("AttribDomain")
        helpForm.ShowDialog()
    End Sub
End Class
