Option Explicit On 
Option Strict On

Imports System.Collections

Public Class AttribDomain_Range
    Private sDomainMin As String = ""
    Private sDomainMax As String = ""
    Private sMeasUnits As String = ""
    Private dMeasResolve As Decimal = 0
    Private cMoreAttribs As New Collection 'collection of integers = index values of associated attributes 
    Public Sub Clear()
        sDomainMax = ""
        sDomainMin = ""
        sMeasUnits = ""
        dMeasResolve = 0
        cMoreAttribs.Clear()
    End Sub
    Public Function Duplicate() As AttribDomain_Range
        Dim newDomainRange As AttribDomain_Range = New AttribDomain_Range()
        newDomainRange.DomMaximum = sDomainMax
        newDomainRange.DomMinimum = sDomainMin
        newDomainRange.MeasureUnits = sMeasUnits
        newDomainRange.Resolution = dMeasResolve
        Return newDomainRange
    End Function
    Public Property DomMinimum() As String
        Get
            DomMinimum = sDomainMin
        End Get
        Set(ByVal Value As String)
            sDomainMin = Value
        End Set
    End Property

    Public Property DomMaximum() As String
        Get
            DomMaximum = sDomainMax
        End Get
        Set(ByVal Value As String)
            sDomainMax = Value
        End Set
    End Property

    Public Property MeasureUnits() As String
        Get
            MeasureUnits = sMeasUnits
        End Get
        Set(ByVal Value As String)
            sMeasUnits = Value
        End Set
    End Property

    Public Property Resolution() As Decimal
        Get
            Resolution = dMeasResolve
        End Get
        Set(ByVal Value As Decimal)
            dMeasResolve = Value
        End Set
    End Property

    Public Property MoreAttributes() As Collection
        Get
            MoreAttributes = cMoreAttribs
        End Get
        Set(ByVal Value As Collection)
            cMoreAttribs = Value
        End Set
    End Property

End Class
