Option Strict On
Option Explicit On 

Imports System
Imports System.Object
Imports System.Collections
Imports System.Collections.Specialized

Public Class DigitalOrderClass
    Private sFormatName As String = ""
    Private sFormVerNumber As String = ""
    Private sFormatVerDate As String = ""
    Private sFormatSpec As String = ""
    Private bASCII As Boolean = False  'True if ASCII File Structure is present
    Private sRecDelim As String = ""
    Private sN_header As String = ""
    Private sHeader As String = ""
    Private sOrient As String = ""
    Private sCaseSens As String = ""
    Private sAuthentic As String = ""
    Private sQuoteChar As String = ""
    Private sDataFields As New StringCollection
    Private sFormatInfo As String = ""
    Private sDecompress As String = ""
    Private sTransferSize As String = ""
    'Collection holds integer index values linking to cDTransOpt
    Private cTransferOpts As New Collection

    Public Property FormatName() As String
        Get
            FormatName = sFormatName
        End Get
        Set(ByVal Value As String)
            sFormatName = Value
        End Set
    End Property

    Public Property FormatVNum() As String
        Get
            FormatVNum = sFormVerNumber
        End Get
        Set(ByVal Value As String)
            sFormVerNumber = Value
        End Set
    End Property

    Public Property FormatVDate() As String
        Get
            FormatVDate = sFormatVerDate
        End Get
        Set(ByVal Value As String)
            sFormatVerDate = Value
        End Set
    End Property

    Public Property FormatSpec() As String
        Get
            FormatSpec = sFormatSpec
        End Get
        Set(ByVal Value As String)
            sFormatSpec = Value
        End Set
    End Property

    Public Property ASCIIstruct() As Boolean
        Get
            ASCIIstruct = bASCII
        End Get
        Set(ByVal Value As Boolean)
            bASCII = Value
        End Set
    End Property

    Public Property RecordDelim() As String
        Get
            RecordDelim = sRecDelim
        End Get
        Set(ByVal Value As String)
            sRecDelim = Value
        End Set
    End Property

    Public Property NumHeaders() As String
        Get
            NumHeaders = sN_header
        End Get
        Set(ByVal Value As String)
            sN_header = Value
        End Set
    End Property

    Public Property Header() As String
        Get
            Header = sHeader
        End Get
        Set(ByVal Value As String)
            sHeader = Value
        End Set
    End Property

    Public Property Orientation() As String
        Get
            Orientation = sOrient
        End Get
        Set(ByVal Value As String)
            sOrient = Value
        End Set
    End Property

    Public Property CaseSensitive() As String
        Get
            CaseSensitive = sCaseSens
        End Get
        Set(ByVal Value As String)
            sCaseSens = Value
        End Set
    End Property

    Public Property Authentic() As String
        Get
            Authentic = sAuthentic
        End Get
        Set(ByVal Value As String)
            sAuthentic = Value
        End Set
    End Property

    Public Property QuoteChar() As String
        Get
            QuoteChar = sQuoteChar
        End Get
        Set(ByVal Value As String)
            sQuoteChar = Value
        End Set
    End Property

    Public Property DataFields() As StringCollection
        Get
            DataFields = sDataFields
        End Get
        Set(ByVal Value As StringCollection)
            sDataFields = Value
        End Set
    End Property

    Public Property FormatInfo() As String
        Get
            FormatInfo = sFormatInfo
        End Get
        Set(ByVal Value As String)
            sFormatInfo = Value
        End Set
    End Property

    Public Property Decompress() As String
        Get
            Decompress = sDecompress
        End Get
        Set(ByVal Value As String)
            sDecompress = Value
        End Set
    End Property

    Public Property TransferSize() As String
        Get
            TransferSize = sTransferSize
        End Get
        Set(ByVal Value As String)
            sTransferSize = Value
        End Set
    End Property

    Public Property TransOptions() As Collection
        Get
            TransOptions = cTransferOpts
        End Get
        Set(ByVal Value As Collection)
            cTransferOpts = Value
        End Set
    End Property

End Class
