Option Explicit On 
Option Strict On

Imports System
Imports System.Object

Public Class ToolClass
    Private m_sToolDesc As String = ""      'analytical tool description
    Private m_sToolLink As String = ""      'online linkage
    Private m_sToolAccess As String = ""    'tool access instructions
    Private m_sToolOS As String = ""        'tool computer and operating system
    Private m_bTcon As Boolean = False      'tells whether a contact is present
    Private m_bTcite As Boolean = False     'tells whether a citation is present
    Private m_bTciteLWC As Boolean = False  'tells whether a larger work citation is present
    Private m_tCon As New ContactInfo       'tool contact information
    Private m_ToolCite As New CiteInfo      'tool citation information
    Private m_ToolCiteLWC As New CiteInfo   'tool larger work citation

    Property ToolDesc() As String
        Get
            ToolDesc = m_sToolDesc
        End Get
        Set(ByVal Value As String)
            m_sToolDesc = Value
        End Set
    End Property

    Property ToolLink() As String
        Get
            ToolLink = m_sToolLink
        End Get
        Set(ByVal Value As String)
            m_sToolLink = Value
        End Set
    End Property

    Property ToolAccess() As String
        Get
            ToolAccess = m_sToolAccess
        End Get
        Set(ByVal Value As String)
            m_sToolAccess = Value
        End Set
    End Property

    Property ToolOS() As String
        Get
            ToolOS = m_sToolOS
        End Get
        Set(ByVal Value As String)
            m_sToolOS = Value
        End Set
    End Property

    Property boolContact() As Boolean
        Get
            boolContact = m_bTcon
        End Get
        Set(ByVal Value As Boolean)
            m_bTcon = Value
        End Set
    End Property

    Property boolCitation() As Boolean
        Get
            boolCitation = m_bTcite
        End Get
        Set(ByVal Value As Boolean)
            m_bTcite = Value
        End Set
    End Property

    Property boolCiteLWC() As Boolean
        Get
            boolCiteLWC = m_bTciteLWC
        End Get
        Set(ByVal Value As Boolean)
            m_bTciteLWC = Value
        End Set
    End Property

    Property ToolContact() As ContactInfo
        Get
            ToolContact = m_tCon
        End Get
        Set(ByVal Value As ContactInfo)
            m_tCon = Value
        End Set
    End Property

    Property ToolCite() As CiteInfo
        Get
            ToolCite = m_ToolCite
        End Get
        Set(ByVal Value As CiteInfo)
            m_ToolCite = Value
        End Set
    End Property

    Property ToolCiteLWC() As CiteInfo
        Get
            ToolCiteLWC = m_ToolCiteLWC
        End Get
        Set(ByVal Value As CiteInfo)
            m_ToolCiteLWC = Value
        End Set
    End Property

End Class
