Option Explicit On 
Option Strict On

Imports System
Imports System.Object
Imports System.Collections
Imports System.Collections.Specialized
Imports System.Windows.Forms
Imports Microsoft.VisualBasic.ControlChars

Public Class frmMethod
    Inherits System.Windows.Forms.Form
    Public Shared oMethod As MethodClass 'the methodology object being created or edited
    Public Shared sPdelim As String = ""
    Public Shared sKdelim As String = CrLf
    Public Shared bUpdate As Boolean  'tells whether methodology has been updated
    Private Shared sEditType As String '"N" = new methodology, "E" = edit methodology
    'break methodology object into component parts
    Private Shared sMethID As New StringCollection 'methodology identifiers
    Private Shared oCite As New CiteInfo         'current methodology citation
    Private Shared bLWC As Boolean = False
    Friend WithEvents button_example As System.Windows.Forms.Button
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip       'current LWC boolean, initially False
    Private Shared oLWC As New CiteInfo          'current Larger Work Citation


#Region " Windows Form Designer generated code "

    Public Sub New(ByVal oInMeth As MethodClass, ByVal sInType As String)
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        oMethod = oInMeth
        sEditType = sInType

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents btnCancel As System.Windows.Forms.Button
    Friend WithEvents btnOK As System.Windows.Forms.Button
    Friend WithEvents btnDelCite As System.Windows.Forms.Button
    Friend WithEvents btnEditCite As System.Windows.Forms.Button
    Friend WithEvents btnAddCite As System.Windows.Forms.Button
    Friend WithEvents lboxCite As System.Windows.Forms.ListBox
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents btnDelID As System.Windows.Forms.Button
    Friend WithEvents btnEditID As System.Windows.Forms.Button
    Friend WithEvents btnAddID As System.Windows.Forms.Button
    Friend WithEvents lboxMID As System.Windows.Forms.ListBox
    Friend WithEvents txtMDesc As System.Windows.Forms.TextBox
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents cboxMType As System.Windows.Forms.ComboBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(frmMethod))
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.button_example = New System.Windows.Forms.Button
        Me.TextBox1 = New System.Windows.Forms.TextBox
        Me.btnCancel = New System.Windows.Forms.Button
        Me.btnOK = New System.Windows.Forms.Button
        Me.btnDelCite = New System.Windows.Forms.Button
        Me.btnEditCite = New System.Windows.Forms.Button
        Me.btnAddCite = New System.Windows.Forms.Button
        Me.lboxCite = New System.Windows.Forms.ListBox
        Me.Label4 = New System.Windows.Forms.Label
        Me.btnDelID = New System.Windows.Forms.Button
        Me.btnEditID = New System.Windows.Forms.Button
        Me.btnAddID = New System.Windows.Forms.Button
        Me.lboxMID = New System.Windows.Forms.ListBox
        Me.txtMDesc = New System.Windows.Forms.TextBox
        Me.Label3 = New System.Windows.Forms.Label
        Me.cboxMType = New System.Windows.Forms.ComboBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.Panel1.SuspendLayout()
        Me.SuspendLayout()
        '
        'Panel1
        '
        Me.Panel1.AutoScroll = True
        Me.Panel1.Controls.Add(Me.button_example)
        Me.Panel1.Controls.Add(Me.TextBox1)
        Me.Panel1.Controls.Add(Me.btnCancel)
        Me.Panel1.Controls.Add(Me.btnOK)
        Me.Panel1.Controls.Add(Me.btnDelCite)
        Me.Panel1.Controls.Add(Me.btnEditCite)
        Me.Panel1.Controls.Add(Me.btnAddCite)
        Me.Panel1.Controls.Add(Me.lboxCite)
        Me.Panel1.Controls.Add(Me.Label4)
        Me.Panel1.Controls.Add(Me.btnDelID)
        Me.Panel1.Controls.Add(Me.btnEditID)
        Me.Panel1.Controls.Add(Me.btnAddID)
        Me.Panel1.Controls.Add(Me.lboxMID)
        Me.Panel1.Controls.Add(Me.txtMDesc)
        Me.Panel1.Controls.Add(Me.Label3)
        Me.Panel1.Controls.Add(Me.cboxMType)
        Me.Panel1.Controls.Add(Me.Label1)
        Me.Panel1.Controls.Add(Me.Label2)
        Me.Panel1.Location = New System.Drawing.Point(0, 0)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(628, 326)
        Me.Panel1.TabIndex = 0
        '
        'button_example
        '
        Me.button_example.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.button_example.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.button_example.Image = Global.MetaDoc.My.Resources.Resources.app_help_48x48
        Me.button_example.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.button_example.Location = New System.Drawing.Point(507, 12)
        Me.button_example.Name = "button_example"
        Me.button_example.Size = New System.Drawing.Size(110, 48)
        Me.button_example.TabIndex = 33
        Me.button_example.Text = "EXAMPLE"
        Me.button_example.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.button_example.UseVisualStyleBackColor = True
        '
        'TextBox1
        '
        Me.TextBox1.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox1.Dock = System.Windows.Forms.DockStyle.Top
        Me.TextBox1.Font = New System.Drawing.Font("Microsoft Sans Serif", 10.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TextBox1.Location = New System.Drawing.Point(0, 0)
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.ReadOnly = True
        Me.TextBox1.Size = New System.Drawing.Size(628, 16)
        Me.TextBox1.TabIndex = 32
        Me.TextBox1.TabStop = False
        Me.TextBox1.Text = "Information about a single step of field and/or laboratory work"
        Me.TextBox1.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        '
        'btnCancel
        '
        Me.btnCancel.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnCancel.Image = Global.MetaDoc.My.Resources.Resources.Cancel_16x16
        Me.btnCancel.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnCancel.Location = New System.Drawing.Point(545, 291)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.Size = New System.Drawing.Size(75, 23)
        Me.btnCancel.TabIndex = 31
        Me.btnCancel.Text = "Cancel"
        Me.btnCancel.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnOK
        '
        Me.btnOK.Enabled = False
        Me.btnOK.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnOK.Image = Global.MetaDoc.My.Resources.Resources.Ok_16x16
        Me.btnOK.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnOK.Location = New System.Drawing.Point(464, 290)
        Me.btnOK.Name = "btnOK"
        Me.btnOK.Size = New System.Drawing.Size(75, 23)
        Me.btnOK.TabIndex = 30
        Me.btnOK.Text = "OK"
        Me.btnOK.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnDelCite
        '
        Me.btnDelCite.Enabled = False
        Me.btnDelCite.Image = CType(resources.GetObject("btnDelCite.Image"), System.Drawing.Image)
        Me.btnDelCite.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnDelCite.Location = New System.Drawing.Point(365, 291)
        Me.btnDelCite.Name = "btnDelCite"
        Me.btnDelCite.Size = New System.Drawing.Size(75, 23)
        Me.btnDelCite.TabIndex = 29
        Me.btnDelCite.Text = "Delete"
        '
        'btnEditCite
        '
        Me.btnEditCite.Enabled = False
        Me.btnEditCite.Image = CType(resources.GetObject("btnEditCite.Image"), System.Drawing.Image)
        Me.btnEditCite.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnEditCite.Location = New System.Drawing.Point(284, 290)
        Me.btnEditCite.Name = "btnEditCite"
        Me.btnEditCite.Size = New System.Drawing.Size(75, 23)
        Me.btnEditCite.TabIndex = 28
        Me.btnEditCite.Text = "Edit"
        '
        'btnAddCite
        '
        Me.btnAddCite.Image = CType(resources.GetObject("btnAddCite.Image"), System.Drawing.Image)
        Me.btnAddCite.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnAddCite.Location = New System.Drawing.Point(203, 290)
        Me.btnAddCite.Name = "btnAddCite"
        Me.btnAddCite.Size = New System.Drawing.Size(75, 23)
        Me.btnAddCite.TabIndex = 27
        Me.btnAddCite.Text = "Add"
        '
        'lboxCite
        '
        Me.lboxCite.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxCite.Location = New System.Drawing.Point(170, 246)
        Me.lboxCite.Name = "lboxCite"
        Me.lboxCite.Size = New System.Drawing.Size(270, 39)
        Me.lboxCite.TabIndex = 26
        Me.ToolTip1.SetToolTip(Me.lboxCite, "Methodology Citation")
        '
        'Label4
        '
        Me.Label4.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label4.Location = New System.Drawing.Point(8, 237)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(120, 24)
        Me.Label4.TabIndex = 25
        Me.Label4.Text = "Methodology Citation"
        Me.ToolTip1.SetToolTip(Me.Label4, "Methodology Citation")
        '
        'btnDelID
        '
        Me.btnDelID.Enabled = False
        Me.btnDelID.Image = CType(resources.GetObject("btnDelID.Image"), System.Drawing.Image)
        Me.btnDelID.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnDelID.Location = New System.Drawing.Point(365, 217)
        Me.btnDelID.Name = "btnDelID"
        Me.btnDelID.Size = New System.Drawing.Size(75, 23)
        Me.btnDelID.TabIndex = 24
        Me.btnDelID.Text = "Delete"
        '
        'btnEditID
        '
        Me.btnEditID.Enabled = False
        Me.btnEditID.Image = CType(resources.GetObject("btnEditID.Image"), System.Drawing.Image)
        Me.btnEditID.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnEditID.Location = New System.Drawing.Point(284, 217)
        Me.btnEditID.Name = "btnEditID"
        Me.btnEditID.Size = New System.Drawing.Size(75, 23)
        Me.btnEditID.TabIndex = 23
        Me.btnEditID.Text = "Edit"
        '
        'btnAddID
        '
        Me.btnAddID.Image = CType(resources.GetObject("btnAddID.Image"), System.Drawing.Image)
        Me.btnAddID.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnAddID.Location = New System.Drawing.Point(203, 217)
        Me.btnAddID.Name = "btnAddID"
        Me.btnAddID.Size = New System.Drawing.Size(75, 23)
        Me.btnAddID.TabIndex = 22
        Me.btnAddID.Text = "Add"
        '
        'lboxMID
        '
        Me.lboxMID.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxMID.Location = New System.Drawing.Point(170, 172)
        Me.lboxMID.Name = "lboxMID"
        Me.lboxMID.Size = New System.Drawing.Size(270, 39)
        Me.lboxMID.TabIndex = 21
        Me.ToolTip1.SetToolTip(Me.lboxMID, "Methodology Identifier (optional)")
        '
        'txtMDesc
        '
        Me.txtMDesc.Location = New System.Drawing.Point(170, 66)
        Me.txtMDesc.Multiline = True
        Me.txtMDesc.Name = "txtMDesc"
        Me.txtMDesc.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtMDesc.Size = New System.Drawing.Size(450, 100)
        Me.txtMDesc.TabIndex = 20
        Me.ToolTip1.SetToolTip(Me.txtMDesc, "Methodology Description")
        '
        'Label3
        '
        Me.Label3.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label3.Location = New System.Drawing.Point(8, 69)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(152, 23)
        Me.Label3.TabIndex = 19
        Me.Label3.Text = "Methodology Description"
        Me.ToolTip1.SetToolTip(Me.Label3, "Methodology Description")
        '
        'cboxMType
        '
        Me.cboxMType.Items.AddRange(New Object() {"Field", "Lab"})
        Me.cboxMType.Location = New System.Drawing.Point(170, 39)
        Me.cboxMType.Name = "cboxMType"
        Me.cboxMType.Size = New System.Drawing.Size(189, 21)
        Me.cboxMType.TabIndex = 18
        Me.ToolTip1.SetToolTip(Me.cboxMType, "Methodology Type")
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.Location = New System.Drawing.Point(8, 42)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(112, 23)
        Me.Label1.TabIndex = 16
        Me.Label1.Text = "Methodology Type"
        Me.ToolTip1.SetToolTip(Me.Label1, "Methodology Type")
        '
        'Label2
        '
        Me.Label2.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label2.Location = New System.Drawing.Point(8, 172)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(176, 24)
        Me.Label2.TabIndex = 17
        Me.Label2.Text = "Methodology Identifier (optional)"
        Me.ToolTip1.SetToolTip(Me.Label2, "Methodology Identifier (optional)")
        '
        'ToolTip1
        '
        Me.ToolTip1.IsBalloon = True
        Me.ToolTip1.ShowAlways = True
        Me.ToolTip1.ToolTipIcon = System.Windows.Forms.ToolTipIcon.Info
        '
        'frmMethod
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.AutoScroll = True
        Me.ClientSize = New System.Drawing.Size(629, 328)
        Me.ControlBox = False
        Me.Controls.Add(Me.Panel1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "frmMethod"
        Me.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Methodology"
        Me.Panel1.ResumeLayout(False)
        Me.Panel1.PerformLayout()
        Me.ResumeLayout(False)

    End Sub

#End Region


    Private Sub frmMethod_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim iSelInd As Integer
        Dim iLoop As Integer
        Dim s1 As String
        Dim sGenArray() As String

        'initialize
        sMethID = New StringCollection
        oCite = New CiteInfo
        bLWC = False
        oLWC = New CiteInfo

        If (sEditType = "N") Then
            'new methodology, no setup
            Return
        End If

        'if (sEditType = "E") then set up to edit existing methodology
        'process Methodology Type
        s1 = oMethod.MethodType
        If (s1 = "") Then
            cboxMType.SelectedIndex = -1 'no choice made yet
        Else
            iSelInd = cboxMType.FindStringExact(s1) 'try to find methodology type in list
            If (iSelInd = -1) Then
                cboxMType.Text = s1 'if not present, place type into combo box
            Else
                cboxMType.SelectedIndex = iSelInd 'if present, then select
            End If
        End If

        'process Methodology Identifier
        sMethID = oMethod.MethodID
        iSelInd = sMethID.Count
        If (iSelInd > 0) Then
            iSelInd = iSelInd - 1
            For iLoop = 0 To iSelInd
                s1 = Replace(sMethID(iLoop), sPdelim, ": ")
                s1 = Replace(s1, sKdelim, "; ")
                lboxMID.Items.Add(s1)
            Next
        End If

        'process Methodology Description
        txtMDesc.Text = oMethod.MethodDesc

        'process Methodology Citations
        iSelInd = oMethod.CiteCount
        If (iSelInd > 0) Then
            For iLoop = 1 To iSelInd
                oCite = oMethod.FetchCite(iLoop)
                s1 = oCite.Author & ":  " & oCite.Title
                lboxCite.Items.Add(s1)
            Next
        End If
    End Sub

    Private Sub btnAddID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddID.Click
        Dim s1 As String = ""
        Dim frmNewMID As New frmMethodID
        frmNewMID.ShowDialog()
        If frmNewMID.getUpdated() Then 'add the new methodology identifier
            s1 = frmNewMID.getKeyDesc() 'get the identifier
            sMethID.Add(s1)         'add it to the collection
            s1 = Replace(s1, sPdelim, ":  ")  'replace pound sterling for display purposes
            s1 = Replace(s1, sKdelim, "; ")   'replace carriage return for display purposes
            lboxMID.Items.Add(s1) 'add to list box
        End If
    End Sub

    Private Sub btnEditID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditID.Click
        Dim iCount As Integer = lboxMID.Items.Count
        Dim iSelInd As Integer = lboxMID.SelectedIndex 'get selected methodology identifier to edit
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No Methodology Identifier selected for editing!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim s1 As String = sMethID(iSelInd) 'retrieve the identifier to be edited
        Dim frmEditMID As New frmMethodID(s1)
        frmEditMID.ShowDialog()
        If (frmEditMID.getUpdated() = True) Then 'add the new methodology identifier
            s1 = frmEditMID.getKeyDesc() 'get the identifier
            sMethID.RemoveAt(iSelInd) 'remove old version from collection
            sMethID.Insert(iSelInd, s1) 'insert new version into collection
            s1 = Replace(s1, sPdelim, ":  ")  'replace pound sterling for display purposes
            s1 = Replace(s1, sKdelim, "; ")   'replace carriage return for display purposes
            lboxMID.Items.RemoveAt(iSelInd) 'remove old version from list box
            lboxMID.Items.Insert(iSelInd, s1) 'insert new version into list box
        End If
        btnEditID.Enabled = False
        btnDelID.Enabled = False
    End Sub

    Private Sub btnDelID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelID.Click
        Dim iSelInd As Integer = lboxMID.SelectedIndex 'get selected methodology identifier to delete
        If (iSelInd = -1) Then
            MessageBox.Show("No Methodology Identifier selected for deletion!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        sMethID.RemoveAt(iSelInd) 'update collection, 0-based index
        lboxMID.Items.RemoveAt(iSelInd) 'update list box, 0-based index
        btnEditID.Enabled = False
        btnDelID.Enabled = False

    End Sub

    Private Sub btnAddCite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddCite.Click
        Dim s1 As String = ""
        Dim iSelInd As Integer = 0
        Dim iTime As Integer = frmMetaMain.intTimeStyle
        oCite = New CiteInfo
        bLWC = False
        oLWC = New CiteInfo
        Dim frmNewMcite As New frmCiteInfo(oCite, oLWC, bLWC, iTime)
        frmNewMcite.ShowDialog()
        If frmNewMcite.getUpdated() Then 'add the new methodology citation
            oCite = frmNewMcite.getNewCite() 'get the main citation
            bLWC = frmNewMcite.getLWC() 'get the LWC boolean
            oLWC = frmNewMcite.getNewLWC() 'get the LWC
            oMethod.CiteAdd() 'adds generic citation to collection
            iSelInd = oMethod.CiteCount 'this is also index of most recent addition
            oMethod.CiteUpdate(oCite, iSelInd) 'updates the generic main citation
            oMethod.LWCUpdate(bLWC, oLWC, iSelInd) 'updates the generic LWC
            s1 = oCite.Author & ":  " & oCite.Title 'create list box entry
            lboxCite.Items.Add(s1) 'add to list box
        End If

    End Sub

    Private Sub btnEditCite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditCite.Click
        Dim iCount As Integer = lboxCite.Items.Count
        Dim iSelInd As Integer = lboxCite.SelectedIndex 'get selected methodology citation to edit
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No Methodology Citation selected for editing!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim s1 As String = ""
        Dim iTime As Integer = frmMetaMain.intTimeStyle
        oCite = oMethod.FetchCite(iSelInd + 1)
        bLWC = oMethod.FetchLWC_b(iSelInd + 1)
        oLWC = oMethod.FetchLWC(iSelInd + 1)
        Dim frmNewMcite As New frmCiteInfo(oCite, oLWC, bLWC, iTime)
        frmNewMcite.ShowDialog()
        If frmNewMcite.getUpdated() Then 'add the new methodology citation
            oCite = frmNewMcite.getNewCite() 'get the main citation
            bLWC = frmNewMcite.getLWC() 'get the LWC boolean
            oLWC = frmNewMcite.getNewLWC() 'get the LWC
            s1 = oCite.Author & ":  " & oCite.Title 'create list box entry
            lboxCite.Items.RemoveAt(iSelInd) 'remove old version from list box, 0-based index
            lboxCite.Items.Insert(iSelInd, s1) 'insert new version into list box
            iSelInd += 1 'this translates to 1-based index
            oMethod.CiteUpdate(oCite, iSelInd) 'updates the main citation
            oMethod.LWCUpdate(bLWC, oLWC, iSelInd) 'updates the LWC
        End If
        btnEditCite.Enabled = False
        btnDelCite.Enabled = False
    End Sub

    Private Sub btnDelCite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelCite.Click
        Dim iSelInd As Integer = lboxCite.SelectedIndex 'get selected methodology citation to delete
        If (iSelInd = -1) Then
            MessageBox.Show("No Methodology Citation selected for deletion!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        oMethod.CiteRemove(iSelInd + 1) 'update citation collection, 1-based index
        lboxCite.Items.RemoveAt(iSelInd) 'update list box, 0-based index
        btnEditCite.Enabled = False
        btnDelCite.Enabled = False
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        If (cboxMType.Text = "") Then
            MessageBox.Show("Need to specify Methodology Type", "Insufficient information", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (txtMDesc.Text = "") Then
            MessageBox.Show("Need a Methodology Description", "Insufficient information", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        bUpdate = True
        oMethod.MethodType = cboxMType.Text
        oMethod.MethodID = sMethID
        oMethod.MethodDesc = txtMDesc.Text
        Me.Close()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        bUpdate = False
        Me.Close()
    End Sub

    Public Function getUpdated() As Boolean
        Return bUpdate
    End Function
    Public Function getMethod() As MethodClass
        Return oMethod
    End Function

    Private Sub txtMDesc_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtMDesc.TextChanged
        If txtMDesc.Text.Trim() = "" Or cboxMType.SelectedIndex = -1 Then btnOK.Enabled = False Else btnOK.Enabled = True
    End Sub

    Private Sub cboxMType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboxMType.SelectedIndexChanged
        If txtMDesc.Text.Trim() = "" Or cboxMType.SelectedIndex = -1 Then btnOK.Enabled = False Else btnOK.Enabled = True
    End Sub

    Private Sub lboxCite_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lboxCite.SelectedIndexChanged
        If lboxCite.SelectedItems.Count > 0 Then btnEditCite.Enabled = True : btnDelCite.Enabled = True Else btnEditCite.Enabled = False : btnDelCite.Enabled = False

    End Sub

    Private Sub lboxMID_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lboxMID.SelectedIndexChanged
        If lboxMID.SelectedItems.Count > 0 Then btnEditID.Enabled = True : btnDelID.Enabled = True Else btnEditID.Enabled = False : btnDelID.Enabled = False
    End Sub

    Private Sub button_example_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_example.Click
        Dim helpForm As dialog_help = New dialog_help("Method")
        helpForm.ShowDialog()
    End Sub
End Class
