Option Explicit On 
Option Strict On

Imports System.Collections
Imports System.Collections.Specialized

Public Class frmPolyEdit
    Inherits System.Windows.Forms.Form
    Public Shared sEditType As String = "" ' "points" or "string"
    Public Shared sPolyDesc As String = "" ' holds the points or g-ring as single string
    Public Shared bUpdate As Boolean = False
    Public sPointPairs As New StringCollection ' holds the point pairs if present
    Public Shared iCount As Integer = 0
    Friend WithEvents button_example As System.Windows.Forms.Button
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip    ' number of point pairs
    Public sPdelim As String = "" 'delimiter between point pairs in single string


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        sEditType = ""
        sPolyDesc = ""
        bUpdate = False
        sPointPairs = New StringCollection
        iCount = 0
    End Sub

    Public Sub New(ByVal sType As String, ByVal sPoly As String)
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        sEditType = sType
        sPolyDesc = sPoly

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents rdoPoints As System.Windows.Forms.RadioButton
    Friend WithEvents rdoRing As System.Windows.Forms.RadioButton
    Friend WithEvents Panel2 As System.Windows.Forms.Panel
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents lboxGPoint As System.Windows.Forms.ListBox
    Friend WithEvents btnAdd As System.Windows.Forms.Button
    Friend WithEvents btnEdit As System.Windows.Forms.Button
    Friend WithEvents btnDelete As System.Windows.Forms.Button
    Friend WithEvents Panel3 As System.Windows.Forms.Panel
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents txtGring As System.Windows.Forms.TextBox
    Friend WithEvents btnOK As System.Windows.Forms.Button
    Friend WithEvents btnCancel As System.Windows.Forms.Button
    Friend WithEvents Label6 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(frmPolyEdit))
        Me.Label1 = New System.Windows.Forms.Label
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.rdoRing = New System.Windows.Forms.RadioButton
        Me.rdoPoints = New System.Windows.Forms.RadioButton
        Me.Panel2 = New System.Windows.Forms.Panel
        Me.btnDelete = New System.Windows.Forms.Button
        Me.btnEdit = New System.Windows.Forms.Button
        Me.btnAdd = New System.Windows.Forms.Button
        Me.lboxGPoint = New System.Windows.Forms.ListBox
        Me.Label3 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.Panel3 = New System.Windows.Forms.Panel
        Me.Label6 = New System.Windows.Forms.Label
        Me.txtGring = New System.Windows.Forms.TextBox
        Me.Label5 = New System.Windows.Forms.Label
        Me.Label4 = New System.Windows.Forms.Label
        Me.btnOK = New System.Windows.Forms.Button
        Me.btnCancel = New System.Windows.Forms.Button
        Me.button_example = New System.Windows.Forms.Button
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.Panel1.SuspendLayout()
        Me.Panel2.SuspendLayout()
        Me.Panel3.SuspendLayout()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(13, 26)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(184, 23)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "The polygon will be described using"
        '
        'Panel1
        '
        Me.Panel1.Controls.Add(Me.rdoRing)
        Me.Panel1.Controls.Add(Me.rdoPoints)
        Me.Panel1.Location = New System.Drawing.Point(194, 12)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(184, 40)
        Me.Panel1.TabIndex = 1
        Me.Panel1.TabStop = True
        '
        'rdoRing
        '
        Me.rdoRing.Location = New System.Drawing.Point(96, 8)
        Me.rdoRing.Name = "rdoRing"
        Me.rdoRing.Size = New System.Drawing.Size(72, 24)
        Me.rdoRing.TabIndex = 1
        Me.rdoRing.TabStop = True
        Me.rdoRing.Text = "G-ring"
        Me.ToolTip1.SetToolTip(Me.rdoRing, resources.GetString("rdoRing.ToolTip"))
        '
        'rdoPoints
        '
        Me.rdoPoints.Location = New System.Drawing.Point(8, 8)
        Me.rdoPoints.Name = "rdoPoints"
        Me.rdoPoints.Size = New System.Drawing.Size(88, 24)
        Me.rdoPoints.TabIndex = 0
        Me.rdoPoints.TabStop = True
        Me.rdoPoints.Text = "G-ring points"
        Me.ToolTip1.SetToolTip(Me.rdoPoints, "a single geographic location.")
        '
        'Panel2
        '
        Me.Panel2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Panel2.Controls.Add(Me.btnDelete)
        Me.Panel2.Controls.Add(Me.btnEdit)
        Me.Panel2.Controls.Add(Me.btnAdd)
        Me.Panel2.Controls.Add(Me.lboxGPoint)
        Me.Panel2.Controls.Add(Me.Label3)
        Me.Panel2.Controls.Add(Me.Label2)
        Me.Panel2.Location = New System.Drawing.Point(16, 64)
        Me.Panel2.Name = "Panel2"
        Me.Panel2.Size = New System.Drawing.Size(386, 161)
        Me.Panel2.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.Panel2, "a single geographic location.")
        '
        'btnDelete
        '
        Me.btnDelete.Enabled = False
        Me.btnDelete.Image = Global.MetaDoc.My.Resources.Resources.file_del_16x16
        Me.btnDelete.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnDelete.Location = New System.Drawing.Point(296, 130)
        Me.btnDelete.Name = "btnDelete"
        Me.btnDelete.Size = New System.Drawing.Size(75, 23)
        Me.btnDelete.TabIndex = 5
        Me.btnDelete.Text = "Delete"
        '
        'btnEdit
        '
        Me.btnEdit.Enabled = False
        Me.btnEdit.Image = Global.MetaDoc.My.Resources.Resources.file_edit_16x16
        Me.btnEdit.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnEdit.Location = New System.Drawing.Point(215, 130)
        Me.btnEdit.Name = "btnEdit"
        Me.btnEdit.Size = New System.Drawing.Size(75, 23)
        Me.btnEdit.TabIndex = 4
        Me.btnEdit.Text = "Edit"
        '
        'btnAdd
        '
        Me.btnAdd.Image = Global.MetaDoc.My.Resources.Resources.file_new_16x16
        Me.btnAdd.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnAdd.Location = New System.Drawing.Point(134, 130)
        Me.btnAdd.Name = "btnAdd"
        Me.btnAdd.Size = New System.Drawing.Size(75, 23)
        Me.btnAdd.TabIndex = 3
        Me.btnAdd.Text = "Add"
        '
        'lboxGPoint
        '
        Me.lboxGPoint.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxGPoint.Location = New System.Drawing.Point(11, 59)
        Me.lboxGPoint.Name = "lboxGPoint"
        Me.lboxGPoint.Size = New System.Drawing.Size(360, 65)
        Me.lboxGPoint.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.lboxGPoint, "a single geographic location.")
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(8, 24)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(352, 32)
        Me.Label3.TabIndex = 1
        Me.Label3.Text = "(at least 3 need to be entered, and in appropriate order; the last point, closing" & _
            " the polygon, will be added automatically)"
        '
        'Label2
        '
        Me.Label2.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label2.Location = New System.Drawing.Point(8, 8)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(88, 23)
        Me.Label2.TabIndex = 0
        Me.Label2.Text = "G-ring Points"
        Me.ToolTip1.SetToolTip(Me.Label2, "a single geographic location.")
        '
        'Panel3
        '
        Me.Panel3.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Panel3.Controls.Add(Me.Label6)
        Me.Panel3.Controls.Add(Me.txtGring)
        Me.Panel3.Controls.Add(Me.Label5)
        Me.Panel3.Controls.Add(Me.Label4)
        Me.Panel3.Location = New System.Drawing.Point(16, 231)
        Me.Panel3.Name = "Panel3"
        Me.Panel3.Size = New System.Drawing.Size(386, 128)
        Me.Panel3.TabIndex = 3
        Me.ToolTip1.SetToolTip(Me.Panel3, resources.GetString("Panel3.ToolTip"))
        '
        'Label6
        '
        Me.Label6.Location = New System.Drawing.Point(8, 24)
        Me.Label6.Name = "Label6"
        Me.Label6.Size = New System.Drawing.Size(264, 23)
        Me.Label6.TabIndex = 3
        Me.Label6.Text = "(There is no error checking on the ring you enter.)"
        '
        'txtGring
        '
        Me.txtGring.Location = New System.Drawing.Point(11, 46)
        Me.txtGring.Multiline = True
        Me.txtGring.Name = "txtGring"
        Me.txtGring.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtGring.Size = New System.Drawing.Size(360, 75)
        Me.txtGring.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.txtGring, resources.GetString("txtGring.ToolTip"))
        '
        'Label5
        '
        Me.Label5.Location = New System.Drawing.Point(72, 8)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(160, 23)
        Me.Label5.TabIndex = 1
        Me.Label5.Text = "format: (lat,long),(lat,long), ..."
        '
        'Label4
        '
        Me.Label4.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label4.Location = New System.Drawing.Point(8, 8)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(56, 23)
        Me.Label4.TabIndex = 0
        Me.Label4.Text = "G-ring"
        Me.ToolTip1.SetToolTip(Me.Label4, resources.GetString("Label4.ToolTip"))
        '
        'btnOK
        '
        Me.btnOK.Enabled = False
        Me.btnOK.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnOK.Image = Global.MetaDoc.My.Resources.Resources.Ok_16x16
        Me.btnOK.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnOK.Location = New System.Drawing.Point(246, 365)
        Me.btnOK.Name = "btnOK"
        Me.btnOK.Size = New System.Drawing.Size(75, 23)
        Me.btnOK.TabIndex = 4
        Me.btnOK.Text = "OK"
        Me.btnOK.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnCancel
        '
        Me.btnCancel.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnCancel.Image = Global.MetaDoc.My.Resources.Resources.Cancel_16x16
        Me.btnCancel.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnCancel.Location = New System.Drawing.Point(327, 365)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.Size = New System.Drawing.Size(75, 23)
        Me.btnCancel.TabIndex = 5
        Me.btnCancel.Text = "Cancel"
        Me.btnCancel.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'button_example
        '
        Me.button_example.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.button_example.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.button_example.Image = Global.MetaDoc.My.Resources.Resources.app_help_48x48
        Me.button_example.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.button_example.Location = New System.Drawing.Point(382, 12)
        Me.button_example.Name = "button_example"
        Me.button_example.Size = New System.Drawing.Size(110, 48)
        Me.button_example.TabIndex = 21
        Me.button_example.Text = "EXAMPLE"
        Me.button_example.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.button_example.UseVisualStyleBackColor = True
        '
        'ToolTip1
        '
        Me.ToolTip1.IsBalloon = True
        Me.ToolTip1.ShowAlways = True
        Me.ToolTip1.ToolTipIcon = System.Windows.Forms.ToolTipIcon.Info
        '
        'frmPolyEdit
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.AutoScroll = True
        Me.ClientSize = New System.Drawing.Size(504, 396)
        Me.ControlBox = False
        Me.Controls.Add(Me.button_example)
        Me.Controls.Add(Me.btnCancel)
        Me.Controls.Add(Me.btnOK)
        Me.Controls.Add(Me.Panel3)
        Me.Controls.Add(Me.Panel2)
        Me.Controls.Add(Me.Panel1)
        Me.Controls.Add(Me.Label1)
        Me.Cursor = System.Windows.Forms.Cursors.Default
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Name = "frmPolyEdit"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "G-Polygon Edit"
        Me.ToolTip1.SetToolTip(Me, "the closed nonintersecting boundary of an interior area. ")
        Me.Panel1.ResumeLayout(False)
        Me.Panel2.ResumeLayout(False)
        Me.Panel3.ResumeLayout(False)
        Me.Panel3.PerformLayout()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub frmPolyEdit_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim sTemp() As String ' temporary holding for the point pairs
        Dim sPoints(1) As String ' will hold the 2 points of a point pair
        Dim sList As String
        Dim iLoop As Integer = 0

        If (sEditType = "") Then
            Panel1.Enabled = True
            Panel2.Enabled = False
            Panel3.Enabled = False
        ElseIf (sEditType = "points") Then
            Panel2.Enabled = True
            rdoPoints.Checked = True
            Panel3.Enabled = False
            sTemp = Split(sPolyDesc, sPdelim)
            iCount = sTemp.GetUpperBound(0)
            For iLoop = 0 To iCount - 1 'recall that last point is same as first; do not want included
                sPointPairs.Add(sTemp(iLoop))
                sPoints = Split(sTemp(iLoop))
                sList = "lat: " & sPoints(0) & "   long: " & sPoints(1)
                lboxGPoint.Items.Add(sList)
            Next
        ElseIf (sEditType = "string") Then
            Panel2.Enabled = False
            Panel3.Enabled = True
            rdoRing.Checked = True
            txtGring.Text = sPolyDesc
        Else
            MessageBox.Show("Error in PolyEditType", "Polygon Edit error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Me.Dispose()
        End If
    End Sub

    Private Sub rdoPoints_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoPoints.CheckedChanged
        If (rdoPoints.Checked = True) Then
            Panel2.Enabled = True
            Panel3.Enabled = False
            sEditType = "points"
        Else
            Panel2.Enabled = False
            Panel3.Enabled = True
            sEditType = "string"
        End If
        validateOK()
    End Sub

    Private Sub rdoRing_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoRing.CheckedChanged
        If (rdoPoints.Checked = True) Then
            Panel2.Enabled = True
            Panel3.Enabled = False
            sEditType = "points"
        Else
            Panel2.Enabled = False
            Panel3.Enabled = True
            sEditType = "string"
        End If
        validateOK()
    End Sub

    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim slist As String = ""

        Dim frmNewPoints As New frmPolyPoints
        frmNewPoints.ShowDialog()
        If (frmNewPoints.getUpdated() = True) Then
            s1 = frmNewPoints.getLat()   'get latitude
            s2 = frmNewPoints.getLong()  'get longitude
            slist = "lat: " & s1 & "   long: " & s2 'form the list box entry
            lboxGPoint.Items.Add(slist)  'add pair to list box
            slist = s1 & " " & s2    'form the space delimited pair
            sPointPairs.Add(slist)   'add pair to collection
        End If
        validateOK()
    End Sub

    Private Sub btnEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEdit.Click
        Dim sTemp() As String
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim slist As String = ""
        Dim iCount As Integer = lboxGPoint.Items.Count
        Dim iCurInd As Integer = lboxGPoint.SelectedIndex
        If (iCount = 1) Then iCurInd = 0
        If (iCurInd = -1) Then 'no point selected for editing
            MessageBox.Show("One of the points must be selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        sTemp = Split(sPointPairs(iCurInd)) 'break selected point into latitude and longitude parts
        Dim frmNewPoints As New frmPolyPoints(sTemp(0), sTemp(1))
        frmNewPoints.ShowDialog()
        If (frmNewPoints.getUpdated() = True) Then
            s1 = frmNewPoints.getLat()   'get latitude
            s2 = frmNewPoints.getLong()  'get longitude
            slist = s1 & " " & s2    'form the space delimited pair
            sPointPairs.Insert(iCurInd, slist)  'add pair to collection
            sPointPairs.RemoveAt(iCurInd + 1) 'remove old pair
            slist = "lat: " & s1 & "   long: " & s2
            lboxGPoint.Items.Insert(iCurInd, slist) 'add pair to list box
            lboxGPoint.Items.RemoveAt(iCurInd + 1)
        End If
        btnEdit.Enabled = False : btnDelete.Enabled = False
        validateOK()
    End Sub

    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        Dim iCurInd As Integer
        iCurInd = lboxGPoint.SelectedIndex
        If (iCurInd = -1) Then 'no index selected
            MessageBox.Show("No G-ring point selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else                   'remove selected point pair
            sPointPairs.RemoveAt(iCurInd)
            lboxGPoint.Items.RemoveAt(iCurInd)
        End If
        btnEdit.Enabled = False : btnDelete.Enabled = False
        validateOK()
        Return
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Dim iLoop As Integer = 0

        If (sEditType = "points") Then 'create the delimited string of points from the collection elements
            sPolyDesc = ""
            iCount = sPointPairs.Count
            If (iCount < 3) Then
                MessageBox.Show("At least 3 points needed!", "Insufficient points to return", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
            For iLoop = 0 To iCount - 1
                sPolyDesc = sPolyDesc & sPointPairs(iLoop) & sPdelim
            Next
            sPolyDesc = sPolyDesc & sPointPairs(0) 'close the ring by repeating first point
            bUpdate = True
        ElseIf (sEditType = "string") Then 'set the G-ring description
            sPolyDesc = txtGring.Text.Trim
            If (sPolyDesc = "") Then
                bUpdate = False
            Else
                bUpdate = True
            End If
        Else
            bUpdate = False
        End If
        Me.Dispose()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        bUpdate = False
        Me.Dispose()
    End Sub

    Private Sub lboxGPoint_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lboxGPoint.SelectedIndexChanged
        If lboxGPoint.SelectedItems.Count() > 0 Then btnEdit.Enabled = True : btnDelete.Enabled = True Else btnEdit.Enabled = False : btnDelete.Enabled = False
    End Sub

    Private Sub txtGring_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtGring.TextChanged
        validateOK()
    End Sub
    Private Sub validateOK()
        If rdoPoints.Checked Then
            If lboxGPoint.Items.Count() < 3 Then btnOK.Enabled = False Else btnOK.Enabled = True
        ElseIf rdoRing.Checked Then
            If txtGring.Text.Trim() = "" Then btnOK.Enabled = False Else btnOK.Enabled = True
        End If
    End Sub
    Public Function getUpdated() As Boolean
        Return bUpdate
    End Function
    Public Function getEditType() As String
        Return sEditType
    End Function
    Public Function getPolyDesc() As String
        Return sPolyDesc
    End Function

    Private Sub button_example_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_example.Click
        Dim helpForm As dialog_help = New dialog_help("PolyEdit")
        helpForm.ShowDialog()
    End Sub
End Class
